-- Forlorn Fox, Caves of chaos level
-- Copyright © 2016 Rob Probin.
-- No redistribution without permission.
--
local function save_state_fn()
        debugMessage("Saving state of caves11")
end

RawMapData {
    "########## ##############",
    "##########d##############",
    "####### m       #########",
    "##  ##           s#######",
    "# c t  /    k      D   ##",
    "#w ###          m####    ",
    "####### m  /    #########",
    "#######          ########",
    "#########s#   ##d###   ##",
    "######### ######    c   #",
    "#########  ########w   ##",
    "##########1##############",
    
    spawn_line = 10.5,
    spawn_column = 2,
    
    title = "Caves of Chaos - Kobold",
    exit_north = nil, --"caves21",
    exit_south = nil,
    exit_west = nil,
    exit_east = nil,--"caves21",
    exits = {
                ['1'] = { file='caves/caves11', destination='2' },
            },
    conditionals =
    {
        exit_doors = 'closed',
    },
    features = { 
        { '#', from_utf8('#'), "AutoWall" },
        { ' ', ' ',            "Space" },
        { 'c', 'c',            "Space" }, 
        { 'w', {500, get_glyph('caves2',23 ), get_glyph('caves2',24 ), get_glyph('caves2', 25), get_glyph('caves2', 26), get_glyph('caves2', 27 ), get_glyph('caves2', 28 ), get_glyph('caves2', 29 )}, "Wall" },
        { 'm', get_glyph('caves1', 31),            "Space" }, -- mould - just decoration
        { 's', get_glyph('caves1', 30),            "Space" }, -- scratch - just decoration
        { '/', get_glyph('caves1', 0x2f), "Space" },

        },
    doors = 
    {
        ['d'] =
        {
            conditional = 'exit_doors',
            closed = get_glyph('caves1', 5),
            open = get_glyph('caves1', 21),
        },
        ['D'] =
        {
            conditional = 'exit_doors',
            closed = get_glyph('caves1', 4),
            open = get_glyph('caves1', 20),
        },
        ['t'] =
        {
            conditional = 'exit_doors',
            closed = get_glyph('caves1', 4),
            open = get_glyph('caves1', 20),
        },
    },
    ---[[
    mobs = 
    { 
        ['k'] = 
        { 
            file = 'mobs/make_kobold',
            map_character = ' ',
        } 
    },--]]
    controllers = { },
    objects = { 
        on_map = {
            ['c'] = 'gold coin'
            }
    },
    fg = 'WHITE',
    bg = 'Saddle_Brown',    
    autowall_glyph_set = "blackwall",
    
    save_state = save_state_fn,
    
    manager_file = 'caves/caves_game_manager',
    manager_name = 'cave_game_manager',     -- will need to be instanced if we want more than 1 game ongoing at a time
                                            -- unless we make the manager stateless and keep all state in the map structure
    preload = { 
        {file='caves/caves_infirmary' },    -- keep infirmary in memory in clients
    },        
    
}
