-- Forlorn Fox
-- Copyright © 2014 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--
RawMapData {
    "################################",
    "###*#*#*#       #     #        #",
    "###             # ### #  k     #",
    "### # # #       # #   #  This  #",
    "### # # #       # # ### opens  #",
    "### # # #       # # #    the   #",
    "### # # #       # # #    Door! #",
    "### # # #       # # #          #",
    "### # # #       # # #          #",
    "### # # #       # # #        ###",
    "1 # # # #       # # #        # 2",
    "#@# # # #       # # #        # #",
    "#       #       * # #        # #",
    "### ############### #       ## #",
    "#       #           #       d !#",
    "#       # #############     ####",
    "# ##### #                      #",
    "#       ### ### ### ############",
    "# ## ## ### ### ### #           ",
    "#       ###*###*###*#           ",
    "#####################           ",
    title = "Level 3",
    exits = { 
        ['1'] = {map_character = get_glyph('spectrum', 32)},        -- entrance only
        ['2'] = { file = 'eyebeast_escape/win', destination = '1', mode='singleplayer' },
    },
    features = 
    { 
        { '#', from_utf8('#'), "AutoWall" },
        { ' ', ' ',            "Space" },
        { 'd', 'd',                         "Space" }, -- door
        { 'k', get_glyph('dragon',0xC0),    "Space" }, -- key
        { '@', get_glyph('blackwall',0xA0), "Space" }, -- timer
        { '!', get_glyph('blackwall',0xA1), "Space" }, -- timer
    },
    conditionals =
    {
        red_door = 'closed',
    },
    doors = 
    {
        ['d'] =
        {
            conditional = 'red_door',
            closed = get_glyph('blackwall',0x05),
            open = get_glyph('blackwall',0x06),
        },
    },
    active_floor = 
    {
        -- set conditional
        [get_glyph('dragon',0xC0)]    = { "set",   'red_door',    'open',  get_glyph('dragon',0xC1)   },        
        [get_glyph('blackwall',0xA0)] = { "timer", 'level_timer', 'start' },        
        [get_glyph('blackwall',0xA1)] = { "timer", 'level_timer', 'stop' },        
    },
    mobs = 
    { 
        ['*'] = 
        { 
            file = 'mobs/widdershins_eyebeast', 
            map_character = ' '
        } 
    },
    preload = { 
        {file='singleplayer_lobby', mode='common_area'},    -- keep lobby in memory in clients
    },        
    fg = 'X11_DIM_GRAY',
    bg = 'X11_PURPLE',
    autowall_glyph_set = "blackwall",
    
    manager_name = 'eyebeast_escape_manager',
    reset_all_mobs_on_death = true,
    
    timer_location = { 18, 21 },

}
