-- Forlorn Fox
-- Copyright © 2015 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--
RawMapData {
    --[[
    map data procedurally generated
    --]]
    title = "Maze Race",
    manager_file = 'maze_tag_manager',
    manager_name = 'maze_tag_manager_2_player',  -- will need to be instanced if we want more than 1 game ongoing at a time
    
    procedural = {
            width = 32,
            height = 21,
            map_type = 'maze',  -- hard to navigate, but all exits guaranteed to be connected
            exits = {
                    -- specify locations of fixed exits to be inserted into the map data
                    ['1'] = {   line = 0,  column = 10     }, 
                    ['2'] = {   line = 0,  column = 21     }, 
                    ['3'] = {   line = 20, column = 15,    },
            },
            
    },
    
    exits = { 
        ['1'] = {map_character = get_glyph('spectrum', 32)},        -- exit
        ['2'] = {map_character = get_glyph('spectrum', 32)},        -- entrance
        ['3'] = {map_character = get_glyph('spectrum', 32), notification = 'reached_exit'},        
    },
    
    next_map = 'maze_tag_2_player_b',
    
    preload = { 
        {file='maze_tag_lobby', mode='common_area'},    -- keep lobby in memory in clients
        {file='maze_tag_2_player_b'},    
    },        
    
    features = { 
            { '#', from_utf8('#'), "AutoWall" },
            { ' ', ' ',            "Space" },
            { '1', '1',            "Space" }, -- entrance / exit
            { '2', '2',            "Space" }, -- entrance / exit
            { '3', '3',            "Space" }, -- entrance / exit
            { 'c', 'c',            "Space" }, -- entrance / exit
        },
    
    controllers = { },
    
    fg = 'BLACK',
    bg = 'X11_PURPLE',
    laser = 'BLUE',
    
    number_of_buried_gold_coin = 0,
    number_of_unburied_gold_coin = 0,
    
}
