-- Forlorn Fox
-- Copyright © 2014 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--
local function gate()
    return get_glyph("tree", 30)
end

RawMapData {
    "################################################################################################",
    "#                                                                                              #",
    "#           #       #                #      #       #                #      #       #          #",
    "#                          #                               #                               #   #",
    "#     ?   #                               #            #                  #            #       #",
    "#                                    #                               #                         #",
    "#                        #                               #                               #     #",
    "#               #                               #                               #              #",
    "#         *1*                                        #           *3*                 #         #",
    "#       #       #                       #       #                       #       #              #",
    "#                                                                                              #",
    "# #                          #    #   *2*                    #    #                          # #",
    "#                                                                                              #",
    "# #      #     #           # #    #      #     #           # #    #      #     #           # # #",
    "#                                                                                              #",
    "# #      #     #     #     # #    #      #     #     #     # #    #      #     #     #     # # #",
    "#                                                                                              #",
    "# #         #                #    #         #                #    #         #                # #",
    "#                                                                                              #",
    "#                                                                                              #",
    "#                                                                                              #",
    "#                                 *5*                                   *4*                    #",
    "#                        #                               #                               #     #",
    "#    #      #       #                #              #                #      #       #          #",
    "#                          #                                                               #   #",
    "#         #            #                  #            #   *a*            #            #       #",
    "#    #          *6*                  #                               #                         #",
    "#                        #                               #                               #     #",
    "#               #                               #                               #              #",
    "#                    #                               #                               #         #",
    "#       #       #                       #       #                       #       #              #",
    "#                                                                                              #",
    "# #                          #    #                          #    #                          # #",
    "#                                                                                              #",
    "# #      #     #           # #    #      #     #           # #    #      #     #           # # #",
    "#                                                *8*                                           #",
    "# #      #     #     #     # #    #      #     #     #     # #    #      #     #     #     # # #",
    "#                                                                                              #",
    "# #         #                #    #         #                #    #         # *9*            # #",
    "#                  *7*                                                                         #",
    "#                                                                                              #",
    "################################################################################################",
    title = "Treehouse",
    --[[
    exits = {   ['1'] = { file = 'maze_of_madness_tunnel', destination = '1' },
                ['2'] = { file = 'central_cavern', destination = '3' }     
    },
    --]]
    controllers = { },
    objects = 
    { 
        { 
            object_type = 'building', 
            object_data = { line = 3, column = 3, height = 5, width = 5 }
        }, 
        { 
            object_type = 'tree', 
            object_data = { line = 7, column = 10 }
        }, 
        { 
            object_type = 'tree', 
            object_data = { line = 10, column = 38 }
        }, 
        { 
            object_type = 'tree', 
            object_data = { line = 7, column = 65 }
        }, 
        { 
            object_type = 'tree', 
            object_data = { line = 25, column = 16 }
        }, 
        { 
            object_type = 'tree', 
            object_data = { line = 20, column = 34 }
        }, 
        { 
            object_type = 'tree', 
            object_data = { line = 24, column = 59 }
        }, 
        { 
            object_type = 'tree', 
            object_data = { line = 20, column = 72 }
        }, 
        { 
            object_type = 'tree', 
            object_data = { line = 38, column = 19 }
        }, 
        { 
            object_type = 'tree', 
            object_data = { line = 34, column = 49 }
        }, 
        { 
            object_type = 'tree', 
            object_data = { line = 37, column = 78 }
        }, 
    },
    features = { 
        { '#', from_utf8('#'), "AutoWall", "treemap" },
        { '*', from_utf8('*'), "AutoWall", "tree" },
        { ' ', ' ',            "Space" },
        { '1', from_utf8('1'),         "Space_InfluenceAutoWall", gate() }, 
        { '2', from_utf8('2'),         "Space_InfluenceAutoWall", gate() }, 
        { '3', from_utf8('3'),         "Space_InfluenceAutoWall", gate() }, 
        { '4', from_utf8('4'),         "Space_InfluenceAutoWall", gate() }, 
        { '5', from_utf8('5'),         "Space_InfluenceAutoWall", gate() }, 
        { '6', from_utf8('6'),         "Space_InfluenceAutoWall", gate() }, 
        { '7', from_utf8('7'),         "Space_InfluenceAutoWall", gate() }, 
        { '8', from_utf8('8'),         "Space_InfluenceAutoWall", gate() }, 
        { '9', from_utf8('9'),         "Space_InfluenceAutoWall", gate() }, 
        { 'a', from_utf8('a'),         "Space_InfluenceAutoWall", gate() }, 
    },
    exits = {
                ['?'] = 
                {
                    file = "new_central_cavern",
                    destination = '8',
                    map_character = get_glyph('map',0x14),
                },
                ['1'] = {destination='5', map_character = gate()}, -- map here to make display work properly
                ['2'] = {destination='8', map_character = gate()}, -- map here to make display work properly
                ['3'] = {destination='a', map_character = gate()}, -- map here to make display work properly
                ['4'] = {destination='9', map_character = gate()}, -- map here to make display work properly
                ['5'] = {destination='1', map_character = gate()}, -- map here to make display work properly
                ['6'] = {destination='3', map_character = gate()}, -- map here to make display work properly
                ['7'] = {destination='2', map_character = gate()}, -- map here to make display work properly
                ['8'] = {destination='4', map_character = gate()}, -- map here to make display work properly
                ['9'] = {destination='7', map_character = gate()}, -- map here to make display work properly
                ['a'] = {destination='6', map_character = gate()}, -- map here to make display work properly
            },
    fg = 'WHITE',
    bg = 'Light_Green',
    laser = 'BLUE',
}
