
-- Forlorn Fox
-- Copyright © 2014 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--
-- Kobold Player character (avatar)
-- Information

local TXT = require("text_strings")

    -- Tony's Kobold

local AvatarData = {
    
    avatar_name = TXT.kobold_avatar_name,
    avatar_type = TXT.kobold_avatar_type,
    -- the center might need to be done on a graphic-by-graphic basis
    avatar_center_in_cells = { 8/16, 10/16 }, -- center bottom { x, y }
    avatar_size_in_cells = { 5/16, 12/16 }, -- uses center in calculation  { x, y }
    
    collision_rect = { centre = { line=1, column=1/2 }, size = { line=1/4, column=1/2 } }, -- centre = { l, c }, size = { l, c }
    
    graphic_unicode_point = get_glyph("caves1", 0xa0),
    
    -- these are not used yet
    base_health_point = 6,
    object_type = "solid", 
        
    has_sword = true,
    
    walk_distance_per_animation_cycle = (3),
    time_for_stationary_animation_cycle = 1,

    speed = 5,
    
    
    east_animation = { get_glyph("caves1",0xb0), get_glyph("caves1",0xb1), get_glyph("caves1",0xb2), get_glyph("caves1",0xb2), 
                       get_glyph("caves1",0xb3), get_glyph("caves1",0xb3), get_glyph("caves1",0xb4), get_glyph("caves1",0xb4), 
                       get_glyph("caves1",0xb5), get_glyph("caves1",0xb5), get_glyph("caves1",0xb6), get_glyph("caves1",0xb7),
                       get_glyph("caves1",0xb8), get_glyph("caves1",0xb9), get_glyph("caves1",0xba), get_glyph("caves1",0xba), 
                       get_glyph("caves1",0xbb), get_glyph("caves1",0xbb), get_glyph("caves1",0xbc), get_glyph("caves1",0xbc), 
                       get_glyph("caves1",0xbd), get_glyph("caves1",0xbd), get_glyph("caves1",0xbe), get_glyph("caves1",0xbf) },
    west_animation = { get_glyph("caves1",0xc0), get_glyph("caves1",0xc1), get_glyph("caves1",0xc2), get_glyph("caves1",0xc2), 
                       get_glyph("caves1",0xc3), get_glyph("caves1",0xc3), get_glyph("caves1",0xc4), get_glyph("caves1",0xc4), 
                       get_glyph("caves1",0xc5), get_glyph("caves1",0xc5), get_glyph("caves1",0xc6), get_glyph("caves1",0xc7),
                       get_glyph("caves1",0xc8), get_glyph("caves1",0xc9), get_glyph("caves1",0xca), get_glyph("caves1",0xca), 
                       get_glyph("caves1",0xcb), get_glyph("caves1",0xcb), get_glyph("caves1",0xcc), get_glyph("caves1",0xcc), 
                       get_glyph("caves1",0xcd), get_glyph("caves1",0xcd), get_glyph("caves1",0xce), get_glyph("caves1",0xcf) },
    north_animation= { get_glyph("caves1",0x78), get_glyph("caves1",0x79), get_glyph("caves1",0x7a), get_glyph("caves1",0x7b), 
                       get_glyph("caves1",0x7c), get_glyph("caves1",0x7d), get_glyph("caves1",0x7e), get_glyph("caves1",0x7f) },
    south_animation= { get_glyph("caves1",0x68), get_glyph("caves1",0x69), get_glyph("caves1",0x6a), get_glyph("caves1",0x6b), 
                       get_glyph("caves1",0x6c), get_glyph("caves1",0x6d), get_glyph("caves1",0x6e), get_glyph("caves1",0x6f) },
    
    east_still_animation = { get_glyph("caves1",0xb0), get_glyph("caves1",0xb0), get_glyph("caves1",0xb0), get_glyph("caves1",0xb1) }, 
    west_still_animation = { get_glyph("caves1",0xc0), get_glyph("caves1",0xc0), get_glyph("caves1",0xc0), get_glyph("caves1",0xc1) }, 
    north_still_animation= { get_glyph("caves1",0x78), get_glyph("caves1",0x78), get_glyph("caves1",0x78), get_glyph("caves1",0x79) }, 
    south_still_animation= { get_glyph("caves1",0xa0), get_glyph("caves1",0xa0), get_glyph("caves1",0xa0), get_glyph("caves1",0xa1) }, 
    
    
    compound_glyphs = {
        {
            name = 'sword',
            east_animation = { get_glyph("caves1",0xa2),get_glyph("caves1",0xa3),get_glyph("caves1",0xa4),get_glyph("caves1",0xa5), 
                               get_glyph("caves1",0xa6),get_glyph("caves1",0xa5),get_glyph("caves1",0xa4),get_glyph("caves1",0xa3),
                               layer = 1 },
            west_animation = { get_glyph("caves1",0xa7),get_glyph("caves1",0xa8),get_glyph("caves1",0xa9),get_glyph("caves1",0xaa), 
                               get_glyph("caves1",0xab),get_glyph("caves1",0xaa),get_glyph("caves1",0xa9),get_glyph("caves1",0xa8),
                               layer = -1 },
            north_animation= { get_glyph("caves1",0xaf), layer = 0 },
            south_animation= { get_glyph("caves1",0xda), layer = 0 },
            
            east_still_animation = { get_glyph("caves1",0xa2), layer = 1 },
            west_still_animation = { get_glyph("caves1",0xa7), layer = -1 },
            north_still_animation= { get_glyph("caves1",0xaf), layer = 0 },
            south_still_animation= { get_glyph("caves1",0xda), layer = 0 },
        },
        {    
            name = 'arm',
            initially_visible = true,
            east_animation = { get_glyph("caves1",0xd0),get_glyph("caves1",0xd1),get_glyph("caves1",0xd2), 
                               get_glyph("caves1",0xd4),get_glyph("caves1",0xd2),get_glyph("caves1",0xd1),
                               layer = 1 },
            west_animation = { get_glyph("caves1",0xd5),get_glyph("caves1",0xd6),get_glyph("caves1",0xd7), 
                               get_glyph("caves1",0xd9),get_glyph("caves1",0xd7),get_glyph("caves1",0xd6),
                               layer = -1 },
            north_animation= { get_glyph("caves1",0x5f), layer = 0 },
            south_animation= { get_glyph("caves1",0xdb), layer = 0 },
            
            east_still_animation = { get_glyph("caves1",0xd0), layer = 1 },
            west_still_animation = { get_glyph("caves1",0xd5), layer = -1 },
            north_still_animation= { get_glyph("caves1",0x5f), layer = 0 },
            south_still_animation= { get_glyph("caves1",0xdb), layer = 0 },
        },
        {    
            name = 'scabbard',
            initially_visible = true,
            east_animation = { get_glyph("caves1",0xac),get_glyph("caves1",0xad),get_glyph("caves1",0xae),get_glyph("caves1",0xad), layer = -1 }, 
            west_animation = { get_glyph("caves1",0xdc),get_glyph("caves1",0xdd),get_glyph("caves1",0xde),get_glyph("caves1",0xdd), layer = 1 }, 
            north_animation= { get_glyph("caves1",0x5e), layer = 0 },
            south_animation= { get_glyph("caves1",0xdf), layer = 0 },
            
            east_still_animation = { get_glyph("caves1",0xac), layer = -1 },
            west_still_animation = { get_glyph("caves1",0xdc), layer = 1 },
            north_still_animation= { get_glyph("caves1",0x5e), layer = 0 },
            south_still_animation= { get_glyph("caves1",0xdf), layer = 0 },
        },
        {    
            name = 'thrust',
            initially_visible = false,
            east_animation = { get_glyph("caves1",0xe0),get_glyph("caves1",0xe1),get_glyph("caves1",0xe2),get_glyph("caves1",0xe3), 
                               get_glyph("caves1",0xe4),get_glyph("caves1",0xe5),get_glyph("caves1",0xe4),get_glyph("caves1",0xe3),
                               get_glyph("caves1",0xe2),get_glyph("caves1",0xe1),get_glyph("caves1",0xe0), 
                               layer = 1, column_offset = 5/16 }, 
            west_animation = { get_glyph("caves1",0xe6),get_glyph("caves1",0xe7),get_glyph("caves1",0xe8),get_glyph("caves1",0xe9), 
                               get_glyph("caves1",0xea),get_glyph("caves1",0xeb),get_glyph("caves1",0xea),get_glyph("caves1",0xe9),
                               get_glyph("caves1",0xe8),get_glyph("caves1",0xe7),get_glyph("caves1",0xe6), 
                               layer = -1, column_offset = -5/16 }, 
            north_animation= { get_glyph("caves1",0x5e), layer = -1 },
            south_animation= { get_glyph("caves1",0xdf), layer = 1 },
            
            east_still_animation = {    get_glyph("caves1",0xe0),get_glyph("caves1",0xe1),get_glyph("caves1",0xe2),get_glyph("caves1",0xe3), 
                                        get_glyph("caves1",0xe4),get_glyph("caves1",0xe5),get_glyph("caves1",0xe4),get_glyph("caves1",0xe3),
                                        get_glyph("caves1",0xe2),get_glyph("caves1",0xe1),get_glyph("caves1",0xe0), 
                                        layer = 1, column_offset = 5/16 }, 
            west_still_animation = {    get_glyph("caves1",0xe6),get_glyph("caves1",0xe7),get_glyph("caves1",0xe8),get_glyph("caves1",0xe9), 
                                        get_glyph("caves1",0xea),get_glyph("caves1",0xeb),get_glyph("caves1",0xea),get_glyph("caves1",0xe9),
                                        get_glyph("caves1",0xe8),get_glyph("caves1",0xe7),get_glyph("caves1",0xe6), 
                                        layer = -1, column_offset = -5/16 }, 
            north_still_animation= { get_glyph("caves1",0x5e), layer = -1 },
            south_still_animation= { get_glyph("caves1",0xdf), layer = 1 },
            compound_animation_stationary_time = 0.1,
            compound_animation_distance = 0.5,
        }
    }
    
}

return AvatarData

