-- Forlorn Fox
-- Copyright © 2016 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--
-- Slime control class
-- Created by Rob Probin, February 2016

require('strict')
require('utils')        -- for nearby()
class = require('middleclass')
require('graphics/glyph_sets')


local Mob = require("controllers/Mob")

local Slime = class('Slime', Mob)


function Slime:initialize(map_name, walkthough, poisonous, growth_rate)
    Mob.initialize(self, "slime", map_name)
    
    local colour_type = 1 -- should depend upon walkthough, poisonous, growth_rate
    
    local maze = get_maze(map_name)
    local picture = get_glyph("dragon",0x9f)
    local display_element = new_hidden_mob_display_element(maze, picture, self.line, self.column, 101, get_simple_colour_by_name('RED'))
    self.slime_display_element = Mob.register_display_element(self, display_element)
end


function Slime:update(dt)
end



return Slime
