-- Forlorn Fox
-- Copyright © 2014 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--
-- From:
--   http://en.wikipedia.org/wiki/X11_color_names
--   http://en.wikipedia.org/wiki/Web_colors
local x11_colours = {
    Alice_Blue = 0xF0F8FF,
    Antique_White   = 0xFAEBD7,
    Aqua    = 0x00FFFF,
    Cyan = 0x00FFFF,
    Aquamarine  = 0x7FFFD4,
    Azure   = 0xF0FFFF,
    Beige   = 0xF5F5DC,
    Bisque  = 0xFFE4C4,
    Black   = 0x000000,
    Blanched_Almond     = 0xFFEBCD,
    Blue    = 0x0000FF,
    Blue_Violet     = 0x8A2BE2,
    Brown   = 0xA52A2A,
    Burlywood   = 0xDEB887,
    Cadet_Blue  = 0x5F9EA0,
    Chartreuse  = 0x7FFF00,
    Chocolate   = 0xD2691E,
    Coral   = 0xFF7F50,
    Cornflower  = 0x6495ED,
    Cornsilk    = 0xFFF8DC,
    Crimson     = 0xDC143C,
    Cyan    = 0x00FFFF,
    Aqua    = 0x00FFFF,
    Dark_Blue   = 0x00008B,
    Dark_Cyan   = 0x008B8B,
    Dark_Goldenrod  = 0xB8860B,
    Dark_Gray   = 0xA9A9A9,
    Dark_Grey       = 0xA9A9A9,
    Dark_Green  = 0x006400,
    Dark_Khaki  = 0xBDB76B,
    Dark_Magenta    = 0x8B008B,
    Dark_Olive_Green    = 0x556B2F,
    Dark_Orange     = 0xFF8C00,
    Dark_Orchid     = 0x9932CC,
    Dark_Red    = 0x8B0000,
    Dark_Salmon     = 0xE9967A,
    Dark_Sea_Green  = 0x8FBC8F,
    Dark_Slate_Blue     = 0x483D8B,
    Dark_Slate_Gray     = 0x2F4F4F,
    Dark_Slate_Grey     = 0x2F4F4F,
    Dark_Turquoise  = 0x00CED1,
    Dark_Violet     = 0x9400D3,
    Deep_Pink   = 0xFF1493,
    Deep_Sky_Blue   = 0x00BFFF,
    Dim_Gray    = 0x696969,
    Dim_Grey = 0x696969,
    Dodgerr_Blue    = 0x1E90FF,
    Firebrick   = 0xB22222,
    Floral_White    = 0xFFFAF0,
    Forest_Green    = 0x228B22,
    Fuchsia     = 0xFF00FF,
    Magenta         = 0xFF00FF,
    Gainsboro   = 0xDCDCDC,
    Ghost_White     = 0xF8F8FF,
    Gold    = 0xFFD700,
    Goldenrod   = 0xDAA520,
    Gray        = 0xBEBEBE,
    Gray_W3C    = 0x808080,
    Grey            = 0xBEBEBE,
    Green   = 0x00FF00,
    Green_W3C   = 0x008000,
    Green_Yellow    = 0xADFF2F,
    Honeydew    = 0xF0FFF0,
    Hot_Pink    = 0xFF69B4,
    Indian_Red  = 0xCD5C5C,
    Indigo  = 0x4B0082,
    Ivory   = 0xFFFFF0,
    Khaki   = 0xF0E68C,
    Lavender    = 0xE6E6FA,
    Lavender_Blush  = 0xFFF0F5,
    Lawn_Green  = 0x7CFC00,
    Lemon_Chiffon   = 0xFFFACD,
    Light_Blue  = 0xADD8E6,
    Light_Coral     = 0xF08080,
    Light_Cyan  = 0xE0FFFF,
    Light_Goldenrod     = 0xFAFAD2,
    Light_Gray  = 0xD3D3D3,
    Light_Grey = 0xD3D3D3,
    Light_Green     = 0x90EE90,
    Light_Pink  = 0xFFB6C1,
    Light_Salmon    = 0xFFA07A,
    Light_Sea_Green     = 0x20B2AA,
    Light_Sky_Blue  = 0x87CEFA,
    Light_Slate_Gray    = 0x778899,
    Light_Slate_Grey    = 0x778899,
    Light_Steel_Blue    = 0xB0C4DE,
    Light_Yellow    = 0xFFFFE0,
    Lime_W3C    = 0x00FF00,
    Lime_Green  = 0x32CD32,
    Linen   = 0xFAF0E6,
    Magenta     = 0xFF00FF,
    Fuchsia = 0xFF00FF,
    Maroon  = 0xB03060,
    Maroon_W3C  = 0x7F0000,
    Medium_Aquamarine   = 0x66CDAA,
    Medium_Blue     = 0x0000CD,
    Medium_Orchid   = 0xBA55D3,
    Medium_Purple   = 0x9370DB,
    Medium_Sea_Green    = 0x3CB371,
    Medium_Slate_Blue   = 0x7B68EE,
    Medium_Spring_Green     = 0x00FA9A,
    Medium_Turquoise    = 0x48D1CC,
    Medium_Violet_Red   = 0xC71585,
    Midnight_Blue   = 0x191970,
    Mint_Cream  = 0xF5FFFA,
    Misty_Rose  = 0xFFE4E1,
    Moccasin    = 0xFFE4B5,
    Navajo_White    = 0xFFDEAD,
    Navy    = 0x000080,
    Old_Lace    = 0xFDF5E6,
    Olive   = 0x808000,
    Olive_Drab  = 0x6B8E23,
    Orange  = 0xFFA500,
    Orange_Red  = 0xFF4500,
    Orchid  = 0xDA70D6,
    Pale_Goldenrod  = 0xEEE8AA,
    Pale_Green  = 0x98FB98,
    Pale_Turquoise  = 0xAFEEEE,
    Pale_Violet_Red     = 0xDB7093,
    Papaya_Whip     = 0xFFEFD5,
    Peach_Puff  = 0xFFDAB9,
    Peru    = 0xCD853F,
    Pink    = 0xFFC0CB,
    Plum    = 0xDDA0DD,
    Powder_Blue     = 0xB0E0E6,
    Purple  = 0xA020F0,
    Purple_W3C  = 0x7F007F,
    Red     = 0xFF0000,
    Rebecca_Purple  = 0x663399,
    Rosy_Brown  = 0xBC8F8F,
    Royal_Blue  = 0x4169E1,
    Saddle_Brown    = 0x8B4513,
    Salmon  = 0xFA8072,
    Sandy_Brown     = 0xF4A460,
    Sea_Green   = 0x2E8B57,
    Seashell    = 0xFFF5EE,
    Sienna  = 0xA0522D,
    Silver_W3C  = 0xC0C0C0,
    Sky_Blue    = 0x87CEEB,
    Slate_Blue  = 0x6A5ACD,
    Slate_Gray  = 0x708090,
    Slate_Grey      = 0x708090,
    Snow    = 0xFFFAFA,
    Spring_Green    = 0x00FF7F,
    Steel_Blue  = 0x4682B4,
    Tan     = 0xD2B48C,
    Teal    = 0x008080,
    Thistle     = 0xD8BFD8,
    Tomato  = 0xFF6347,
    Turquoise   = 0x40E0D0,
    Violet  = 0xEE82EE,
    Wheat   = 0xF5DEB3,
    White   = 0xFFFFFF,
    White_Smoke     = 0xF5F5F5,
    Yellow  = 0xFFFF00,
    Yellow_Green    = 0x9ACD32,
}

if gulp_cpp.SDL_Color == nil then
    --print(">>>> STUPID SERVER STATE IS INCLUDING A COLOUR FILE WHICH IS ILLEGAL AND BREAKS THINGS <<<< ")
    --x11_colours[k] = { a = 255, r = bit32.extract(colour, 16, 8), g = bit32.extract(colour, 8, 8), b = bit32.extract(colour, 0, 8) }
else
    -- transform all of these to SDL_Colours! (Then we don't need to deal with the wierd pixel order problems)
    for k,colour in pairs(x11_colours) do
        local sdl_colour = gulp_cpp.SDL_Color()
        sdl_colour.a = 255
        sdl_colour.r = bit32.extract(colour, 16, 8)
        sdl_colour.g = bit32.extract(colour, 8, 8)
        sdl_colour.b = bit32.extract(colour, 0, 8)
        x11_colours[k] = sdl_colour
    end
end

return x11_colours
