require ("strict")
local class = require("middleclass")

local ToggleButton = require("../gui/togglebutton")

local ColourToggleButton = class('ColourToggleButton', ToggleButton)


function ColourToggleButton:initialize(button_data)
    if not button_data.first_glyph_down then
        button_data.first_glyph_down = button_data.first_glyph
    end
    if not button_data.fg then
        button_data.fg = get_simple_colour_by_name('CYAN')
    end
    if not button_data.bg then
        button_data.bg = get_SDL_Color_by_name('WHITE')
    end
    ToggleButton.initialize(self, button_data)
end


function ColourToggleButton:adjust_display_elements(glyph)
    for line=self.line, self.line + self.ysize-1 do
        for column=self.column, self.column + self.xsize-1 do
            self.button_display_elements[line][column]:set_glyph(glyph)
            if self.mode == "down" then
                self.button_display_elements[line][column]:set_bg_colour(self.bg)
                self.button_display_elements[line][column]:set_fg_colour(self.fg)
            else
                self.button_display_elements[line][column]:set_bg_colour(get_SDL_Color_by_name('WHITE'))
                self.button_display_elements[line][column]:set_fg_colour(get_simple_colour_by_name('BLACK'))
            end
        
            glyph = glyph + 1
        end
        glyph = glyph + 32 - self.xsize
    end
end


return ColourToggleButton

