-- Forlorn Fox
-- Copyright © 2014 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--

require ("strict")
class = require("middleclass")
require("../graphics/graphics")

local Button = require("../gui/button")
local LockButton = require("../gui/lockbutton")

local ColourButton = LockButton:subclass('ColourButton')


function ColourButton:mousepressed(x, y, handled)
    
    -- record here. The button handling may change self.mode
    local old_mode = self.mode
    
    if not handled then
        handled = Button.mousepressed(self, x, y, handled)
    end
    
    if handled then
        if old_mode == 'down' then
            self.mode = 'further_down'
            self:adjust_display_elements(self.first_glyph_further_down, get_SDL_Color_by_name(self.active_bg_colour))
        else
            self.mode = 'down'
            self:adjust_display_elements(self.first_glyph_down, get_SDL_Color_by_name(self.active_bg_colour))
        end
    end
    
    return handled
end

function ColourButton:adjust_display_elements(glyph, bg_colour)
    for line=self.line, self.line + self.ysize-1 do
        for column=self.column, self.column + self.xsize-1 do
            self.button_display_elements[line][column]:set_glyph(glyph)
            self.button_display_elements[line][column]:set_bg_colour(bg_colour)
            glyph = glyph + 1
        end
        glyph = glyph + 32 - self.xsize
    end
end

function ColourButton:release()
    self.mode = 'up'
    self:adjust_display_elements(self.first_glyph, get_SDL_Color_by_name('WHITE'))
end

--[[
function ColourButton:draw()
    
    if self.mode=='up' then
        Button._internal_draw(self, self.first_glyph)
    else
        local current_bg_colour, current_bg_colour_simple
        
        if self.active_bg_colour ~= nil then
            current_bg_colour = get_current_bg_colour()
            set_bg_colour(self.active_bg_colour)
        end
        
        if self.mode=='down' then
            Button._internal_draw(self, self.first_glyph_down)
        else
            Button._internal_draw(self, self.first_glyph_further_down)
        end
        
        if current_bg_colour ~= nil then
            set_bg_colour(current_bg_colour)
        end
    end
end
--]]

return ColourButton