-- Forlorn Fox
-- Copyright © 2014 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--

require ("strict")
class = require("middleclass")
require("../graphics/graphics")

local Button = require("../gui/button")

local LockButton = Button:subclass('LockButton')


function LockButton:initialize(button_data)
    
    -- initialize some data if it wasn't passed as arguments
    if self.mode == nil then
        self.mode = 'up'
    end
    
    Button.initialize(self, button_data)
    
end
    
    
function LockButton:adjust_display_elements(glyph)

    for line=self.line, self.line + self.ysize-1 do
        for column=self.column, self.column + self.xsize-1 do
            self.button_display_elements[line][column]:set_glyph(glyph)
            glyph = glyph + 1
        end
        glyph = glyph + 32 - self.xsize
    end

end

function LockButton:mousereleased(x, y, handled)
    if not handled then
        handled = Button.mousereleased(self, x, y, handled)
    end

    if handled then
        self:activate()
    end

    return handled
end


function LockButton:mousepressed(x, y, handled)
    if not handled then
        handled = Button.mousepressed(self, x, y, handled)
    end
        
    return handled
end

function LockButton:create_display_elements()
    if self.mode=='up' then
        Button._internal_create_display_elements(self, self.first_glyph)
    else
        Button._internal_create_display_elements(self, self.first_glyph_down)
    end
end
--[[
function LockButton:draw()
    if self.mode=='up' then
        Button._internal_draw(self, self.first_glyph)
    else
        Button._internal_draw(self, self.first_glyph_down)
    end
end
--]]

function LockButton:activate()
    self.mode = 'down'
    self:adjust_display_elements(self.first_glyph_down)
end

function LockButton:release()
    self.mode = 'up'
    self:adjust_display_elements(self.first_glyph)
end


return LockButton