-- Forlorn Fox
-- Copyright © 2014 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--


--[[local]]-- 
GulpNetworking = class('GulpNetworking')

require("strict")
local class = require("middleclass")
local copas = require("copas")
local LANb = require("networking/lan_broadcast")
local Internetb = require("networking/internet_broadcast")
 
local keepAlive = require("networking/keep_alive")

require("networking/network_serializer")

  
-- Turn debugging on or off
gulpNetworkingDebuggingEnabled = false


function GulpNetworking:initialize()
 
  -- Client socket
  self.ServerIP = ""
  self.Port = 0
  self.Servers = {}
  
  self.clientSockets = {}     

  -- Play position sent
  self.lastSentColumn = 0
  self.lastSentLine = 0
  self.moving = false

  self.mobs_id = 100 -- start well above the IDs which might be used for players (1-99)  
  
  -- Don't want copas to auto close the connections
  copas.autoclose = false
  
  self.keepAlive = keepAlive:new(self)
end

function GulpNetworking:finish()
  print("GulpNetworking:finsh")
end

function GulpNetworking:update(dt)
    -- If keep alive is enabled
    if gulp.enableKeepAlive == true then 
        self.keepAlive:tick(dt, self);
    end 
end

if gulp.LuaStateCodeMode == "CLIENT" then
    require("networking/client_low_level")
else
    require("networking/server_low_level")
end

require("networking/network_transport")

GulpNetworking.LANb = LANb
GulpNetworking.Internetb = Internetb

return GulpNetworking

--[[

Rob's & Kenny @todo list for networking
    1.  Change messages over to new format - Kenny
        - Mod Serialise
        - NewMob
        - Gold coin serialise
    
    2.  Change receive over to new format - Kenny
    
    7.  Remove scaffolding mt = “old” from transmit
    
    11. Sort out global vs. self variables
    
    23. Add in latency test system
    
    26. Add IP edit fields IPv6 compatible         
    
    27. Test IPv6 addresses in the boxes
        ⁃ Do an IPv4 / IPv6 / Address  / Port address decoder
        
    31. Add in lua command to check copas threads
       
    Future:
    i)      registered name database (like minecraft)
    ii)     game clearing house / tracker
    iii)    previous game history (list of servers previously connected to)
 
--]]
