-- Forlorn Fox
-- Copyright © 2014 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--

 
require("strict")
local class = require("middleclass")
local splash = class("splash")
local text_sizes = require("utilities/text_sizes")
local SimpleImage = require("utilities/SimpleImage")

function splash:initialize()
    gulp._delegate_list:add_delegate(self)
    gulp.add_user_movement_target(self)
    self._clicked = false
    self._time = 0
    
    self._image = SimpleImage(gulp_cpp.LoadPath("graphics/splash.png"):c_str(), gulp.app:get_SDL_renderer(), text_sizes)
end

function splash:draw(gr)
    text_sizes:set_viewport(gr)
    self._image:draw_center(gr)
end

function splash:update(dt)
    self._time = self._time + dt
    
    if self._terminate and (self._time > 5.0 or self._clicked) then 
        self:close()
    end
    
end

function splash:mousepressed(x, y, handled)
    self._down = true
    return true
end

function splash:mousereleased(x, y, handled)
    -- only close if we've seen a click before
    if self._down == true then
        self._clicked = true
    end
    return true
end

function splash:keypressed(sym, scancode, modifier, repeated)
    if not gulp.function_key_monitor:keypressed(sym, scancode, modifier, repeated) then
        self._clicked = true
    end
    
    return true
end

function splash:load_finished()
    self._terminate = true
end


function splash:close()
    gulp.remove_user_movement_target(self)
    gulp._delegate_list:drop_delegate(self)
    
    -- allow it to be garbage collected
    self._image = nil
    
    gulp.main_menu = main_menu()
end


return splash