-- Forlorn Fox
-- Copyright © 2014 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--

--[[
    
    Generic counting of collectables, per player
    
--]]


require('strict')
local class = require('middleclass')

local CollectableCounter = class('CollectableCounter')

function CollectableCounter:initialize(variable)
    self.variable = variable
end

function CollectableCounter:change_count(player, amount)
    if player[self.variable] == nil then
        player[self.variable] = amount
    else
        player[self.variable] = player[self.variable] + amount
    end
end

function CollectableCounter:change_count_by_id(id, amount)
    local player = get_player_by_id(id)
    if player then
        self:change_count(player, amount)
    end
end

function CollectableCounter:set_count(player, amount)
    player[self.variable] = amount
end

function CollectableCounter:set_count_by_id(id, amount)
    local player = get_player_by_id(id)
    if player then
        self:set_count(player, amount)
    end
end


function CollectableCounter:get_count(player)
    if player[self.variable] == nil then
        player[self.variable] = 0
    end
    return player[self.variable]
end

function CollectableCounter:get_count_by_id(id)
    local player = get_player_by_id(id)
    if player then
        return self:get_count(player)
    end
    return 0
end

return CollectableCounter


