-- Forlorn Fox
-- Copyright © 2015 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--
-- Create list of games
--
-- Created by Rob Probin, September 2015
-- For Forlorn Fox

LANb = require("networking/lan_broadcast")

local manage_lan_listener = class("manage_lan_listener")

local manage_game_list = require("networking/manage_game_list")

function manage_lan_listener:fetch()
    return self.servers
end


function manage_lan_listener:initialize(source_menu, connect_to)
    self.servers = {}
    
    self.game_list = manage_game_list:new(source_menu, connect_to, manage_lan_listener.fetch, self)
    --self.menu = source_menu
    --self.connect_to = connect_to
    self.listener = LANb.listener:new()
    gulp._delegate_list:add_delegate(self)
    --self.number_lan_games_so_far = 0
end



function manage_lan_listener:update(dt)
    -- Should we check dt to make sure plenty of time has passed?
    -- We don't really case - we are not doing anything else
    self.listener:listen()
    self.servers = self.listener:get_server_list()
    
    --[[
    if #servers > self.number_lan_games_so_far then
        for i = self.number_lan_games_so_far+1, #servers do
            
            local game = servers[i]
            local good_ver = game.game_version == gulp.forlorn_fox_version
            local version_ok_string = to_utf8(get_glyph('editor', 3))
            local version_ok_colour = "\x1b[32m\x1b[1m"
            local run_func = 0
            if not good_ver then
                version_ok_string = to_utf8(get_glyph('editor', 1))
                version_ok_colour = "\x1b[31m"
                run_func = nil
            end
            local display1 = string.format(
                "%s%s  v%s %s", 
                version_ok_colour,
                tostring(game.game_name),
                tostring(game.game_version),
                tostring(version_ok_string)
            )
            local display2 = string.format(
                " %s@ %s %s", 
                version_ok_colour,
                tostring(game.game_ip_address),
                tostring(game.game_port)
            )
            self.menu:insert_item( { display1, self.connect_to, game.game_ip_address, game.game_port } )
            self.menu:insert_item( { display2 } )
        end
        self.number_lan_games_so_far = #servers
    end
    --]]
end

function manage_lan_listener:terminate()
    self.listener:terminate_listen()
    gulp._delegate_list:drop_delegate(self)
    self.game_list:terminate()
    --self.menu = nil -- ensure no circular references for garbage collector ... not essential?
end

return manage_lan_listener
