-- Forlorn Fox
-- Copyright © 2014 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--
-- Message queue to send via copas 
local MessageQueue = {}

-- Init the message queue
function MessageQueue.new()
  return {first = 0, last = -1}
end

-- Add message to the send queue    
function MessageQueue.pushMessage(list, socket_ref, message)
   local last = list.last + 1
   list.last = last
   list[last] = {sock = socket_ref, msg = message}
end
    
-- Get message from the queue    
function MessageQueue.popMessage(list)
   local first = list.first
   if first > list.last then 
     return nil, nil -- No message
   end
   
   local socket_ref = list[first].sock
   local message = list[first].msg
   list[first].sock = nil        -- to allow garbage collection
   list[first].msg = nil        -- to allow garbage collection
   list.first = first + 1
   return socket_ref, message
end
  
-- Get number of messages in the queue    
function MessageQueue.waitingMessageCount(list)
  local msg_count = ((list.last - list.first) +1)
  
  if gulpNetworkingDebuggingEnabled then 
        print("Messages waiting to be sent:", msg_count)
    end
    return (msg_count)
end

return MessageQueue
