-- Forlorn Fox
-- Copyright © 2015 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--

--local all_sockets_ever = {}
--local game_running = false

function remember_socket_for_debug(sock_type, sock)
    --table.insert(all_sockets_ever, {sock_type, sock})
end

function remember_game_start_for_debug()
    --table.insert(all_sockets_ever, "Game Start")
    --game_running = true
end

function remember_game_end_for_debug()
    --table.insert(all_sockets_ever, "Game End")
    --game_running = false
end


--[[
local function print_all_sockets()
    print("------------------------------")
    print("All sockets")
    for _,v in pairs(all_sockets_ever) do
        if type(v) == "string" then
            print(v)
        else
            local skt_type = v[1]
            local skt = v[2]
            print(skt_type, tostring(skt), tostring(skt:getsockname()), tostring(skt:getpeername()))
        end
    end
    print("------------------------------")
end
--]]

local SOCKET_NAME_ENABLED = true
local socket_name_table = {}

function name_network_item(socket_to_name, name)
    if SOCKET_NAME_ENABLED then
        socket_name_table[socket_to_name] = name
    end
end

function list_net_item_names_core()
    if SOCKET_NAME_ENABLED then
        for skt,name in pairs(socket_name_table) do
            print(skt, name)
        end
    else
        print("Socket names not enabled")
    end
end

function copas_names()
    print("------ COPAS UI------")
    list_net_item_names_core()
    print("------ COPAS SERVER------")    
    server_run_lua('list_net_item_names_core()')
end


-- This global function prints data about the 
--
--
function netstat()
    print("==============================")

    --local game = "Game running in"
    --if not game_running then
    --    game = "HALTED - "
    --end
    
    if gulp.LuaStateCodeMode == 'SERVER' then
        GulpNetworking:print_server_debug_info()    -- @todo: Need to send a message to the server to get it to print out this data (or send it back to us)!
    else
        print("No client support yet :-)")
    end
        
    --print_all_sockets()
end


function copas_stat()
    print("------ COPAS UI------")
    local copas1 = require("copas")
    copas1.list_all()
    print("------ COPAS SERVER------")    
    server_run_lua('require("copas").list_all()')
end


return true