-- Forlorn Fox
-- Copyright © 2016 Rob Probin, Tony Park and Kenny Osborne.
-- No redistribution without permission.
--
-- Updatng avatar
-- Used on client and server sides to display the player's avatars

-- todo avatar display not needed at server, but server remote player is based on this class
-- and some facilities still used at server, like the player list. 

require('strict')
require('utils')
class = require('middleclass')

local PlayerAvatar = require("player/PlayerAvatar")
local PlayerUpdatingAvatar = class('PlayerUpdatingAvatar', PlayerAvatar)

-- Creates the player
function PlayerUpdatingAvatar:initialize(avatar, colour, id, map_name, tagged, tool, tool_orientation)
    
    PlayerAvatar.initialize(self, avatar, colour, id, map_name, tagged, tool, tool_orientation)
    
    self.dl = 0
    self.dc = 0
    self.last_dl = 0
    self.last_dc = 0
    self.last_animation_mode = 's_st'
    self.animation_time = 0
    
    gulp._delegate_list:add_delegate(self)
   
end

function PlayerUpdatingAvatar:update(dt)
        
    -- animation
    if self.glyphs.avatar then
        self:select_animation_frame(dt)    
    end
    
    
end

function PlayerUpdatingAvatar:processPosition(message)
    
    -- form a view as to what dl and dc should be
    -- we're only interested in direction here, magnitude concerns us not at all
    self.dl = 0
    self.dc = 0
    
    if message.line < self.line then self.dl = -1 end
    if message.line > self.line then self.dl = 1 end
    if message.column < self.column then self.dc = -1 end
    if message.column > self.column then self.dc = 1 end
    
    -- then act dumb
    PlayerAvatar.processPosition(self, message)
end

return PlayerUpdatingAvatar

