-- FiFo Queue
-- Based on Programming in Lua 3rd Edition
-- Section 11.4 Queues and Double Queues


require("strict")
local class = require("middleclass")


local Queue = class("Queue")

function Queue:initialize()
    self.first = 0
    self.last = -1
    self.data = {}
end

function Queue:pushfirst(value)    
    local first = self.first - 1
    self.first = first
    self.data[first] = value
end

function Queue:pushlast(value)
    local last = self.last + 1
    self.last = last
    self.data[last] = value
end

function Queue:popfirst()
    local first = self.first
    if first > self.last then error("Queue is empty") end
    local value = self.data[first]
    self.data[first] = nil       -- to allow garbage collection
    self.first = first + 1
    return value
end

function Queue:poplast()
    local last = self.last
    if self.first > last then error("Queue is empty") end
    local value = self.data[last]
    self.data[last] = nil       -- to allow garbage collection
    self.last = last + 1
    return value
end

function Queue:empty()
    return self.first > self.last
end


return Queue