require("strict")
class = require("middleclass")
require('library/SDL_keycode')


if gulp.LuaStateCodeMode == "SERVER" then
    
    -- server side function code monitoring
    --local FunctionKeyMonitor = class("ServerFunctionKeyMonitor")
    --return FunctionKeyMonitor
    
    --[[
    local Kobold = require("controllers/Kobold")
    
    local function_key_actions = {
        [SDLK.F7] = function() Kobold.adjust_animation(-0.1) end,
        [SDLK.F8] = function() Kobold.adjust_animation(0.1) end,
    }
    --]]
    
    function process_network_fkey(key)
        local action = function_key_actions[key]
        if action then
            action(key)
            return true
        end
        return false
    end
        
    
else


    local MouseMove = require("player/mouse_move")
    local FunctionKeyMonitor = class("FunctionKeyMonitor")
    local GulpNetworking = require("gulp_networking")
    
    function FunctionKeyMonitor:initialize()
        gulp._delegate_list:add_delegate(self)
    end

    function FunctionKeyMonitor:glyph_editor_key()
        gulp.launch_glyph_editor()
    end

    function FunctionKeyMonitor:zoom_in_key()
        self:zoom_key(-1)
    end

    function FunctionKeyMonitor:zoom_out_key()
        self:zoom_key(1)
    end

    function FunctionKeyMonitor:zoom_key(direction)
        local enabled = MouseMove.disable_game_controls()
        gulp_cpp.Zoom(direction)
        MouseMove.restore_game_controls(enabled)
        
        if gulp.localplayer then
            gulp.localplayer:calculate_offsets()
        end
        
    end


    local function_key_actions = {
        [SDLK.F1] = function(sym, scancode, modifier, repeated) 
            gulp.debug:info_toggle()
            end,
        [SDLK.F3] = function(sym, scancode, modifier, repeated) 
            gulp_cpp.ToggleFullscreen(false) 
            end,
        --[SDLK.F4] = FunctionKeyMonitor.zoom_in_key,
        --[SDLK.F5] = FunctionKeyMonitor.zoom_out_key,
        --[SDLK.F6] = FunctionKeyMonitor.glyph_editor_key,
        
        -- these crash, originally send a key to the server
        --[SDLK.F7] = function() GulpNetworking:SendFunctionKey(SDLK.F7) end,
        --[SDLK.F8] = function() GulpNetworking:SendFunctionKey(SDLK.F8) end,
        
        [SDLK.F9] = function(sym, scancode, modifier, repeated) 
            gulp.localplayer:ai_toggle() 
            end,
    }

    function FunctionKeyMonitor:keypressed(sym)
        local action = function_key_actions[sym]
        if action then
            action(self, sym)
            return true
        end
        return false
    end

    return FunctionKeyMonitor

end     -- server / client 

