

function fnG(n)
    if n == 0 then return 0 end
    return n - fnG(fnG(n-1))
end

function G_tree(limit)

    local G = {}
    
    -- fill an array G with our function
    for n = 1, limit do
        G[n] = fnG(n)
    end
    
    -- fill an array link count with the number of links to each node of the tree
    local link_count = {}
    local n = 2
    while n < limit do
        -- count how many point to our location
        local count = 0
        for counter = n, limit do
            if G[counter] == G[n] then
                count = count + 1
            end
        end
        
        link_count [n] = count
        n = n + count
    end
    
    -- calculate line for each node
    local max_line = 1
    local line = {1}    -- first node is on line 1
    for n = 2, limit do
        line[n] = line[G[n]]+1
        if line[n] > max_line then max_line = line[n] end
    end
    
    -- debug printout
    for n = 1, limit do
        io.write(n, ". G(", n, ") = ", G[n])
        print(", ", line[n])
    end
    
    -- build tree 
    local tree = {}
    local n = 1
    for l = 1, max_line do
        local tree_line = {}
        while line[n] == l do
            table.insert(tree_line, n)
            n = n + 1
        end
        table.insert(tree, tree_line)
    end
    
    -- print tree
    -- could print this tree using quarter sized glyphs
    -- evenly space numbers on lines and represent tree structure 
    -- using circles round nodes and joining edges, as per Rob's mouse demo
    for l = 1, max_line do
        local tree_line = tree[l]
        
        -- count the nodes in the line
        local node = next(tree_line)
        local node_count = 0
        while node do
            node_count = node_count+1
            node = next(tree_line, node)
        end
            
        
        local node = next(tree_line)
        while node do
            io.write(tree_line[node], " ")
            node = next(tree_line, node)
        end
        print()
    end
    
    
    
    --[[
    local line_count = {}
    local line = 1
    local count = 1
    local n = 1
    while n < limit do
        -- generate line counts
        if link_count[n] and link_count[n] > 1 then
            count = count + link_count[n] - 1
        end
        n = n + count
        line_count[line] = count
        line = line + 1
    end
    
    local last_line = line
    local n = 1
    for line = 1, last_line do
        io.write("line_count[", line, "]=", line_count[line], "    ")
        
        for x = 1, line_count[line] do
            io.write("G(", n, ")=", G[n], " ")
            n = n + 1
        end
        print()
    end
    --]]
    
end

G_tree(50)

