local namegen = {}

-- We want a large selection of game names
-- There are two methods - precanned and generated. We use both.

-- if we assume we want 25 characters max, that means -2 for spaces, so 23 / 3 =  7/8/8
namegen.adjective = { 'Tiny', 'Big', 'Ugly', 'Cute'}
namegen.colour = { 'Red', 'Blue', 'Pink', 'Gold', 'Green', 'Yellow', 'Silver', 'Orange', 'Purple', 'Black', 'White' }
namegen.thing = { 'Ant', 'Bear', 'Cat', 'Dog', 'Owl', 'Panda', 'Penguin'}

-- We try to limit default game names to 25 characters
namegen.precanned_game_names = {
    "My World",
    "Far far away",
    "Tinkertown",
    "Deep Dungeon",
    "Ancient Ruins",
    "Treasure Island",
    "Lost somewhere",
    "At our house",
    "The land time forgot",
    "Game world",
    "Dragon rooms",
    "Escape rooms",
    "Play me!",
--   0000000001111111111222222
--   1234567890123456789012345
    "Cupboard under the stairs",
    "Blue box",
    "Keep Dungeons",
    "Rainbows end",
    "Blackrock",
    "Sub-basement",
    "Undiscovered country",
    "Deep Forest",
    "Inca Pyramid",
    "Ancient Egypt",
    "Under the great wall",
    "World1",
    "Cartography",
    "Central Cavern",
    "Dr Jones' Footprints",
    "Green Forest",
    "The Forgotten Abbey",
}

namegen.total_num_generated = #namegen.adjective * #namegen.colour * #namegen.thing
namegen.total_number = namegen.total_num_generated + #namegen.precanned_game_names


function namegen.GenerateGameName()
    local selected = math.random(namegen.total_number)
    if selected <= #namegen.precanned_game_names then
        return namegen.precanned_game_names[selected]
    else
        local adjective = namegen.adjective
        local colour = namegen.colour
        local thing = namegen.thing
        return adjective[math.random(#adjective)].." "..colour[math.random(#colour)].." "..thing[math.random(#thing)]
    end
end

return namegen
